############################################
############## radio-0.8.tcl ###############
############################################
# This is the main part of radio-0.8c.tcl! #
############################################

# Auf welchem Chan soll der Bot auf die Radio-Befehle reagieren?
set radio:chan "#radio4life"

# Wie heit das Radio?
set radio:name "Radio4Life"

# Wie ist die Homepage des Radios?
set radio:url "http://www.radio4life.de/"

# Wo wird das Radio gestreamt? (ohne listen.pls)
set radio:stream "http://radio4life.dyn.ee:22000/"

# Welcome-Message an?
set radio:welcome "0"

# Nicht ndern!
set radio:dj ""
set radio:nextdj ""

# Welchen Flag muss jemand haben um den aktuellen DJ zu ndern?
set radio:flag "R|R"

# Soll derjenige, der den Bot MSGt selber DJ sein ("1") oder
# jemand anderes (kann auch sich selber) als DJ bestimmen ("2")?
set radio:dj:mode "2"

# Radio standardmig nicht online
set radio:off "1"

# Befehlsmodus:
# 1: MSG an Bot, 2: Befehlschannel
set radio:commandmode "2"

# Befehlschannel, in dem _jeder_ einen DJ einstellen und das Script deaktivieren kann.
set radio:commandchan "#radio!"

# In welcher Datei soll das Topic gespeichert werden?
set radio:topicfile "radio.topic"

# In welcher Datei soll das interne Topic gespeichert werden?
set radio:inttopicfile "radio.inttopic"

# Soll das Topic beim ndern des DJs gendert werden?
set radio:set:topic "1"

# Soll das interne Topic beim ndern des DJs und des nchsten DJs gendert werden?
# NUR BENUTZEN, WENN EIN ${radio:commandchan} gesetzt wurde!
set radio:set:inttopic "1"

# Botnet Funktion benutzen?
set radio:net:enable "1"

########################
# Script beginnt hier! #
########################
bind pub -|- !url radio:pub:url
bind pub -|- !stream radio:pub:stream
bind pub -|- !dj radio:pub:dj
bind pub -|- !wunsch radio:pub:wunsch
bind pub -|- !gru radio:pub:gruss
bind pub -|- !gruss radio:pub:gruss
bind pub -|- !info radio:pub:info
bind pub -|- !nextdj radio:pub:nextdj
bind msg ${radio:flag} dj radio:msg:dj
bind msg ${radio:flag} radiooff radio:msg:off
bind msg ${radio:flag} nextdj radio:msg:nextdj
bind msg ${radio:flag} next radio:msg:next
bind msg ${radio:flag} topic radio:msg:topic
bind join -|- * radio:join:welcome
bind pub -|- .dj radio:pub:setdj
bind pub -|- .radiooff radio:pub:off
bind pub -|- .info radio:pub:dotinfo
bind pub -|- .nextdj radio:pub:setnextdj
bind pub -|- .next radio:pub:next
bind pub -|- .restart radio:pub:restart
bind pub -|- .topic radio:pub:topic
bind pub -|- .inttopic radio:pub:inttopic
bind pub -|- ?topic radio:pub:topicinfo
bind pub -|- .dotopic radio:pub:dotopic
bind pub -|- .ntopic radio:net:topic
bind bot - radio_wunsch radio:net:wunsch
bind bot - radio_gruss radio:net:gruss
bind bot - radio_status radio:net:sendstatus
bind link - * radio:net:offerstatus

proc radio:pub:url {nick host hand chan arg} {
	global radio:name radio:url radio:chan
        if {$chan == ${radio:chan}} {
                puthelp "NOTICE $nick :Die Homepage von ${radio:name} ist unter ${radio:url} zu erreichen."
	}
}

proc radio:pub:stream {nick host hand chan arg} {
	global radio:name radio:stream radio:off radio:chan
        if {$chan == ${radio:chan}} {
		if {${radio:off}} {
                        puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
                puthelp "NOTICE $nick :Den Stream von ${radio:name} kannst du dir unter ${radio:stream}listen.pls reinziehen!"
	}
}

proc radio:pub:dj {nick host hand chan arg} {
	global radio:dj radio:off radio:chan
        if {$chan == ${radio:chan}} {
		if {${radio:off}} {
                        puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
 		}
                puthelp "NOTICE $nick :Momentan drhnt euch \002${radio:dj}\002 mit seiner/ihrer Musik zu!"
	}
}

proc radio:pub:wunsch {nick host hand chan arg} {
	global radio:name radio:dj radio:off radio:chan radio:wunsch
        set radio:wunsch "$arg"
        if {$chan == ${radio:chan}} {
		if {${radio:off}} {
                        puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
                if {${radio:wunsch} == ""} {
                        puthelp "NOTICE $nick :Du hast keinen Titel angegeben!"
			return 0
		}
                putquick "PRIVMSG ${radio:dj} :04Wunsch: ${radio:wunsch} von $nick."
                puthelp "NOTICE $nick :Dein Wunsch ${radio:wunsch} wurde an ${radio:dj} weitergeleitet. Bitte wnsche dir das nicht noch einmal, da wir den Wunsch sonst ignorieren werden!"
	}
}

proc radio:pub:gruss {nick host hand chan arg} {
	global radio:name radio:dj radio:off radio:chan radio:gruss
        set radio:gruss "$arg"
        if {$chan == ${radio:chan}} {
		if {${radio:off}} {
                        puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
                if {${radio:gruss} == ""} {
                        puthelp "NOTICE $nick :Du hast keinen Gru angegeben!"
			return 0
		}
                putquick "PRIVMSG ${radio:dj} :07Gru: ${radio:gruss} von $nick."
                puthelp "NOTICE $nick :Dein Gru ${radio:gruss} wurde an ${radio:dj} weitergeleitet. Bitte wnsche dir das nicht noch einmal, da wir deinen Gru sonst ignorieren werden!"
	}
}

proc radio:msg:dj {nick host hand arg} {
        global radio:name radio:dj radio:off radio:chan
	global radio:dj:mode radio:commandmode 
	global radio:topicfile radio:topic radio:set:topic
	global radio:net:enable
	if {${radio:commandmode} == "2"} { return 0 }
	if {${radio:dj:mode} == "1"} {
		set radio:dj "$nick"
		if {${radio:off}} {
                        putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
                        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
		}
                putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
		set radio:off "0"
                if {${radio:set:topic} == "1"} {
			source ${radio:topicfile}
                        putserv "TOPIC ${radio:chan} :${radio:topic}"
                }
		if {${radio:net:enable} == "1"} {
			putallbots "radio_dj ${radio:dj}"
		}
        } else {
                if {$arg == ""} {
                        putquick "NOTICE $nick :Du musst schon einen DJ angeben ..."
			return 0
		}
                set radio:dj "$arg"
		if {${radio:off}} {
                        putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
                        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
		}
                putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
                putquick "NOTICE $nick :${radio:dj} wurde als DJ von ${radio:name} eingesetzt."
		set radio:off "0"
                if {${radio:set:topic} == "1"} {
			source ${radio:topicfile}
                        putserv "TOPIC ${radio:chan} :${radio:topic}"
                }
		if {${radio:net:enable} == "1"} {
			putallbots "radio_dj ${radio:dj}"
		}
	}
}

proc radio:msg:off {nick host hand arg} {
        global radio:name radio:off radio:chan radio:dj radio:stream radio:url
	global radio:commandmode
	global radio:topicfile radio:topic radio:set:topic radio:stream
	global radio:net:enable
	if {${radio:commandmode} == "2"} { return 0 }
	set radio:off "1"
        set radio:dj "offline"
	set radio:nextdj "none"
        putquick "NOTICE $nick :Das Radioscript fr ${radio:chan} wurde deaktiviert."
        if {${radio:set:topic} == "1"} {
		source ${radio:topicfile}
                putserv "TOPIC ${radio:chan} :${radio:topic}"
        }
	if {${radio:net:enable} == "1"} {
		putallbots "radio_status off"
	}
}

proc radio:join:welcome {nick uhost hand chan} {
	global radio:name radio:chan botnick radio:welcome
	if {$nick == $botnick} {return 0}
	if {${radio:welcome} == "0"} {return 0}
        if {$chan == ${radio:chan}} {
                puthelp "NOTICE $nick :Willkommen in ${radio:chan}, dem IRC-Channel von ${radio:name}! Dir stehen folgende Befehle zur Verfgung:"
                puthelp "NOTICE $nick :Mit !url kannst du dir die URL zum Channel anzeigen lassen, !stream zeigt dir an, wo du das Radio hren kannst, !dj sagt dir, wer die Musik auflegt und !nextdj zeigt dir, wer den DJ danach ablst. Auerdem kannst du mit !wunsch Musikwnsche und mit !gru Gre an den/die Moderator(in) weitergeben."
        }
}

proc radio:pub:setdj {nick host hand chan arg} {
        global radio:name radio:dj radio:nextdj radio:off radio:chan radio:url radio:stream
	global radio:dj:mode radio:commandmode radio:commandchan
	global radio:topicfile radio:topic radio:set:topic
	global radio:set:inttopic radio:inttopic radio:inttopicfile 
	global radio:net:enable
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
		if {${radio:dj:mode} == "1"} {
			set radio:dj "$nick"
			if {${radio:off}} {
        	                putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
	                        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
			}
	                putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
			set radio:off "0"
                        if {${radio:set:topic} == "1"} {
				source ${radio:topicfile}
                                putserv "TOPIC ${radio:chan} :${radio:topic}"
                        }
			if {${radio:net:enable} == "1"} {
				putallbots "radio_dj ${radio:dj}"
			}
	        } else {
        	        if {$arg == ""} {
                	        putquick "PRIVMSG $chan :Du musst schon einen DJ angeben, $nick..."
				return 0
			}
	                set radio:dj "$arg"
			if {${radio:off}} {
        	                putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
                	        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
			}
        	        putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
	                putquick "PRIVMSG ${radio:commandchan} :${radio:dj} wurde als DJ von ${radio:name} eingesetzt."
			set radio:off "0"
                        if {${radio:set:topic} == "1"} {
				source ${radio:topicfile}
                                putserv "TOPIC ${radio:chan} :${radio:topic}"
                        }
			if {${radio:set:inttopic} == "1"} {
				source ${radio:inttopicfile}
				putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
			}
			if {${radio:net:enable} == "1"} {
				putallbots "radio_dj ${radio:dj}"
			}
		}
	}
}

proc radio:pub:off {nick host hand chan arg} {
        global radio:name radio:off radio:chan radio:stream radio:url radio:dj radio:nextdj
	global radio:commandchan radio:commandmode
	global radio:topic radio:topicfile radio:set:topic
	global radio:set:inttopic radio:inttopic radio:inttopicfile
	global radio:net:enable
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
		set radio:off "1"
                set radio:dj "offline"
		set radio:nextdj "none"
                putquick "PRIVMSG ${radio:commandchan} :Das Radioscript fr ${radio:chan} wurde deaktiviert."
                if {${radio:set:topic} == "1"} {
			source ${radio:topicfile}
                        putserv "TOPIC ${radio:chan} :${radio:topic}"
                }
		if {${radio:set:inttopic} == "1"} {
			source ${radio:inttopicfile}
			putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
		}
		if {${radio:net:enable} == "1"} {
			putallbots "radio_status off"
		}
	}
}

proc radio:pub:info {nick host hand chan arg} {
	global radio:name radio:url radio:chan
        if {$chan == ${radio:chan}} {
                puthelp "NOTICE $nick :Dir stehen folgende Befehle zur Verfgung:"
                puthelp "NOTICE $nick :Mit \002!url\002 kannst du dir die URL zum Channel anzeigen lassen, \002!stream\002 zeigt dir an, wo du das Radio hren kannst, \002!dj\002 sagt dir, wer die Musik auflegt und \002!nextdj\002 zeigt dir, wer den DJ danach ablst. Auerdem kannst du mit \002!wunsch\002 Musikwnsche und mit \002!gru\002 Gre an den/die Moderator(in) weitergeben."
	}
}

proc radio:pub:restart {nick host hand chan arg} {
	global radio:commandmode radio:commandchan
	if {${radio:commandmode} == "1"} { return 0 }
	if {$chan == ${radio:commandchan}} {
		restart
	}
}

proc radio:pub:dotinfo {nick host hand chan arg} {
	global radio:chan
	global radio:dj:mode radio:commandmode radio:commandchan
	global radio:set:topic
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
                puthelp "NOTICE $nick :Dir stehen folgende Befehle zur Verfgung:"
		if {${radio:dj:mode} == "1"} {
			set radio:info:dj "Mit \002.dj\002 wirst \037du\037 zum DJ,"
			set radio:info:nextdj "mit \002.nextdj\002 wird du, wenn jemand \002.next\002 macht, zum DJ,"
		} else {
			set radio:info:dj "Mit \002.dj NICK\002 wird \037NICK\037 zum DJ,"
			set radio:info:nextdj "mit \002.nextdj NICK\002 wird \037NICK\037, wenn jemand \002.next\002 macht, zum DJ,"
		}
		set radio:info:restart "\002.restart\002 startet den Bot neu"
		set radio:info:off "und \002.radiooff\002 stellt dieses Radioscript aus."
		if {${radio:set:topic} == "1"} {
			set radio:info:topic "Informationen zu den Befehlen \002.topic\002 und \002.inttopic\002 bekommst du, wenn du \002?topic\002 eingibst."
		} else {
			set radio:info:topic ""
		}
		puthelp "NOTICE $nick :${radio:info:dj} ${radio:info:nextdj} ${radio:info:restart} ${radio:info:off} ${radio:info:topic}"
	}
}

proc radio:pub:topicinfo {nick host hand chan arg} {
	global radio:chan
	global radio:commandmode radio:commandchan radio:dj:mode
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
                puthelp "NOTICE $nick :Mit \002.topic\002 kannst du das Topic, das beim ndern des DJs oder Ausschalten des Radioscripts (DJ \"offline\") gesetzt wird, ndern. Beachte dabei, dass Zeichen wie \],\[,\",\},\{,\\ u.. mit dem Prefix \\ geschrieben werden _mssen_!"
		puthelp "NOTICE $nick :Beispiel: \".topic \\\[ \${radio:name} \\\] \\\[ @ \${radio:dj} \\\] \\\[ Stream: \${radio:stream}listen.pls \\\]"
		puthelp "NOTICE $nick :Die gleichen Regeln gelten beim Setzen des Topics fr den Internchan. (\002.inttopic\002)"
	}
}

proc radio:pub:nextdj {nick host hand chan arg} {
	global radio:name radio:chan radio:nextdj radio:dj radio:off
        if {$chan == ${radio:chan}} {
		if {${radio:off}} {
                        puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
 		}
                if {${radio:nextdj} == ""} {
                        puthelp "NOTICE $nick :Es wurde noch keine Ablsung fr ${radio:dj} eingesetzt."
                        return 0
                }
                putquick "NOTICE $nick :${radio:nextdj} wird ${radio:dj} nachher ablsen."
	}
}

proc radio:pub:setnextdj {nick host hand chan arg} {
	global radio:name radio:nextdj radio:off radio:chan
	global radio:dj:mode radio:commandmode radio:commandchan
	global radio:inttopic radio:inttopicfile global:set:inttopic
	global radio:net:enable
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
		if {${radio:dj:mode} == "1"} {
			set radio:nextdj "$nick"
	                putquick "PRIVMSG ${radio:commandchan} :${radio:nextdj} wurde als nchster DJ von ${radio:name} eingestellt."
	        } else {
        	        if {$arg == ""} {
                	        putquick "PRIVMSG ${radio:commandchan} :Du musst schon einen DJ angeben, $nick..."
				return 0
			}
	                set radio:nextdj "$arg"
        	        putquick "PRIVMSG ${radio:nextdj} :Du bist der nchste DJ von ${radio:name}."
	                putquick "PRIVMSG ${radio:commandchan} :${radio:nextdj} wurde als nchster DJ von ${radio:name} eingesetzt."
		}
		if {${radio:set:inttopic} == "1"} {
			source ${radio:inttopicfile}
			putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
		}
		if {${radio:net:enable} == "1"} {
			putallbots "radio_nextdj ${radio:nextdj}"
		}
	}
}

proc radio:msg:nextdj {nick host hand arg} {
	global radio:name radio:chan radio:nextdj
	global radio:dj:mode radio:commandmode
	global radio:net:enable
	if {${radio:commandmode} == "2"} { return 0 }
	if {${radio:dj:mode} == "1"} {
		set radio:nextdj "$nick"
		putquick "PRIVMSG $nick :${radio:nextdj} wurde als nchster DJ von ${radio:name} eingestellt."
        } else {
                if {$arg == ""} {
                        putquick "NOTICE $nick :Du musst schon einen DJ angeben ..."
			return 0
		}
                set radio:nextdj "$arg"
		putquick "PRIVMSG ${radio:nextdj} :Du bist der nchste DJ von ${radio:name}."
	        putquick "NOTICE $nick :${radio:nextdj} wurde als nchster DJ von ${radio:name} eingesetzt."
	}
	if {${radio:net:enable} == "1"} {
		putallbots "radio_nextdj ${radio:nextdj}"
	}
}

proc radio:pub:next {nick host hand chan arg} {
        global radio:name radio:dj radio:nextdj radio:off radio:chan radio:stream radio:url
	global radio:commandchan radio:commandmode
	global radio:topicfile radio:topic radio:set:topic 
	global radio:set:inttopic radio:inttopic radio:inttopicfile
	global radio:net:enable
	if {${radio:commandmode} == "1"} { return 0 }
        if {$chan == ${radio:commandchan}} {
		if {${radio:nextdj} == ""} {
			putquick "PRIVMSG ${radio:commandchan} :Es wurde kein nchster DJ gesetzt."
			return 0
		} else {
			set radio:dj "${radio:nextdj}"
			set radio:nextdj "none"
			if {${radio:off}} {
        	                putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
	                        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
			}
	                putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
			set radio:off "0"
                        if {${radio:set:topic} == "1"} {
				source ${radio:topicfile}
                                putserv "TOPIC ${radio:chan} :${radio:topic}"
                        }
			if {${radio:set:inttopic} == "1"} {
				source ${radio:inttopicfile}
				putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
			}
			if {${radio:net:enable} == "1"} {
				putallbots "radio_next next"
			}
			set radio:nextdj ""
		}
	}
}

proc radio:msg:next {nick host hand arg} {
        global radio:name radio:dj radio:nextdj radio:off radio:chan
	global radio:commandmode
	global radio:topicfile radio:topic radio:set:topic 
	global radio:set:inttopic radio:inttopic radio:inttopicfile
	global radio:net:enable
        	if {${radio:commandmode} == "2"} { return 0 }
		if {${radio:nextdj == ""} {
			putquick "PRIVMSG $nick :Es wurde kein nchster DJ gesetzt."
			return 0
		} else {
			set radio:dj "${radio:nextdj}"
			set radio:nextdj "none"
			if {${radio:off}} {
        	                putquick "PRIVMSG ${radio:dj} :Das Radioscript war deaktiviert und wird nun gestartet."
	                        puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
			}
	                putquick "PRIVMSG ${radio:dj} :Du bist jetzt DJ von ${radio:name}."
			set radio:off "0"
                        if {${radio:set:topic} == "1"} {
				source ${radio:topicfile}
                                putserv "TOPIC ${radio:chan} :${radio:topic}"
                        }
			if {${radio:set:inttopic} == "1"} {
				source ${radio:inttopicfile}
				putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
			}
			if {${radio:net:enable} == "1"} {
				putallbots "radio_next next"
			}
		}
	}
}

proc radio:pub:topic {nick host hand chan arg} {
        global radio:chan radio:dj radio:name radio:stream radio:url
	global radio:commandchan radio:commandmode
	global radio:topicfile radio:topic radio:set:topic
        if {${radio:commandmode} == "1"} { return 0 }
	if {[llength $arg] == 0} {
		puthelp "PRIVMSG ${radio:commandchan} :Du hast kein Topic angegeben, $nick!"
		return 0
	}
        if {$chan == ${radio:commandchan}} {
                file delete ${radio:topicfile}
                set radio:openfile [open ${radio:topicfile} w]
		close ${radio:openfile}
                set radio:openfile [open ${radio:topicfile} a+]
		set radio:temptopic "set radio:topic \"$arg\""
                puts ${radio:openfile} ${radio:temptopic}
                close ${radio:openfile}
		source ${radio:topicfile}
                putquick "PRIVMSG ${radio:commandchan} :Das Topic wurde gesetzt: ${radio:topic}."
         }
}

proc radio:msg:topic {nick host hand arg} {
        global radio:chan radio:dj radio:name radio:stream radio:url
	global radio:commandmode
	global radio:topicfile radio:topic radio:set:topic
        if {${radio:commandmode} == "2"} { return 0 }
	if {[llength $arg] == 0} {
		puthelp "NOTICE $nick :Du hast kein Topic angegegeben!"
		return 0
	}
	file delete ${radio:topicfile}
	set radio:openfile [open ${radio:topicfile} w]
	close ${radio:openfile}
	set radio:openfile [open ${radio:topicfile} a+]
	set radio:temptopic "set radio:topic \"$arg\""
	puts ${radio:openfile} ${radio:temptopic}
        close ${radio:openfile}
	source ${radio:topicfile}
        putquick "NOTICE $nick :Das Topic wurde gesetzt: ${radio:topic}."
}

proc radio:pub:inttopic {nick host hand chan arg} {
	global radio:nextdj
        global radio:commandchan radio:commandmode
	global radio:inttopicfile radio:inttopic radio:set:inttopic
        if {${radio:commandmode} == "1"} { return 0 }
	if {${radio:set:inttopic} == "0"} { return 0 }
        if {[llength $arg] == 0} {
                puthelp "PRIVMSG ${radio:commandchan} :Du hast kein Topic angegeben, $nick!"
                return 0
        }
        if {$chan == ${radio:commandchan}} {
                file delete ${radio:inttopicfile}
                set radio:openfile [open ${radio:inttopicfile} w]
                close ${radio:openfile}
                set radio:openfile [open ${radio:inttopicfile} a+]
                set radio:temptopic "set radio:inttopic \"$arg\""
                puts ${radio:openfile} ${radio:temptopic}
                close ${radio:openfile}
                source ${radio:inttopicfile}
                putquick "PRIVMSG ${radio:commandchan} :Das interne Topic wurde gesetzt: ${radio:inttopic}."
         }
}

proc radio:pub:dotopic {nick host hand chan arg} {
	global radio:chan
	global radio:commandchan radio:commandmode
	global radio:topicfile radio:topic radio:set:topic
	global radio:inttopicfile radio:inttopic radio:set:inttopic
	if {${radio:commandmode} == "1"} { return 0 }
	if {${radio:set:inttopic} == "0"} { return 0 }
	if {$chan == ${radio:commandchan}} {
		if {${radio:set:topic} == "1"} {
			source ${radio:topicfile}
			putserv "TOPIC ${radio:chan} :${radio:topic}"
			puthelp "PRIVMSG ${radio:commandchan} :Topic im \002${radio:chan}\002 gesetzt."
		}
		if {${radio:set:inttopic} == "1"} {
			source ${radio:inttopicfile}
			putserv "TOPIC ${radio:commandchan} :${radio:inttopic}"
			puthelp "PRIVMSG ${radio:commandchan} :Topic im \002${radio:commandchan}\002 gesetzt."
		}
	}
}

proc radio:net:wunsch {bot com arg} {
	global radio:dj radio:wunsch
	global radio:net:enable
	set radio:remotenick [lindex $arg 0]
	set radio:wunsch [join [lrange [split $arg " "] 1 end]]
	if {${radio:net:enable} == "1"} {
                putquick "PRIVMSG ${radio:dj} :07Wunsch: ${radio:wunsch} von ${radio:remotenick}."
	}
}

proc radio:net:gruss {bot com arg} {
	global radio:dj radio:gruss
	global radio:net:enable
	set radio:remotenick [lindex $arg 0]
	set radio:gruss [join [lrange [split $arg " "] 1 end]]
	if {${radio:net:enable} == "1"} {
                putquick "PRIVMSG ${radio:dj} :07Gru: ${radio:gruss} von ${radio:remotenick}."
	}
}

proc radio:net:sendstatus {bot com arg} {
	global radio:off radio:dj radio:nextdj
	global radio:net:enable
	if {${radio:net:enable} == "1"} {
		if {${radio:off}} {
			putbot $bot "radio_status off"
		} else {
			putbot $bot "radio_status on"
			putbot $bot "radio_dj ${radio:dj}"
			putbot $bot "radio_nextdj ${radio:nextdj}"
		}
	}
}

proc radio:net:offerstatus {botlinked via} {
	global radio:off radio:dj radio:nextdj
	global radio:net:enable
	if {${radio:net:enable} == "1"} {
		if {${radio:off}} {
			putbot $botlinked "radio_status off"
		} else {
			putbot $botlinked "radio_status on"
			putbot $botlinked "radio_dj ${radio:dj}"
			putbot $botlinked "radio_nextdj ${radio:nextdj}"
		}
	}
}

proc radio:net:topic {nick host hand chan arg} {
	global radio:chan radio:dj radio:name radio:stream radio:url
	global radio:commandchan radio:commandmode
	global radio:net:bot radio:net:topic
	if {${radio:commandmode} == "1"} { return 0 }
	if {[llength $arg] == 0} {
		puthelp "PRIVMSG ${radio:commandchan} :Du hast kein Topic angegeben, $nick!"
		return 0
	}
	if {$chan == ${radio:commandchan}} {
		set radio:net:bot [lindex $arg 0]
		set radio:net:topic [join [lrange [split $arg " "] 1 end]]
		putbot ${radio:net:bot} "radio_topic ${radio:net:topic}"
		putquick "PRIVMSG ${radio:commandchan} :Das Topic wurde gesetzt: ${radio:net:topic}."
         }
}


# History:
# Version 0.8: Botnet-Mode added
#
# Version 0.74: Wenn jemand den DJ setzt und der gleich dem nextDJ ist, wird der nextDJ gelscht. Bugfixes & Adds fr Topic fr ${radio:nextdj} in ${radio:commandchan}, .dotopic added.
#
# Version 0.73: Topicwechsel z.B. fr Anzeige von ${radio:nextdj} fr Intern-Channel, Re-Colourierung, bei ".dj" jetzt "... seiner/ihrer Musik ..." *g*
#
# Version 0.72: Bei Topic setzen jetzt erst berprfung, ob auch was nach ".topic" steht ...
#
# Version 0.71: Andere Befehle zum Lschen und neu Erstellen der ${radio:topicfile}
#
# Version 0.7: Bei !nextdj jetzt auch keine Rckmeldung wenn Radioscript aus ist oder kein ${radio:nextdj} gesetzt wurde, .topic added und automatische nderung des Topics bei DJ-Wechsel (THX to CyBex & thommey @ #tcl @ QuakeNet!)
#
# Version 0.62: !gru & !gruss (wober !gru richtige Rechtschreibung ist und !gruss wenn das System die Umlaute nicht nimmt ...)
#
# Version 0.61: .restart added
#
# Version 0.6: Put-Modi gendert.
#
# Version 0.5: Welcome Message ab nun optional
#
# Version 0.4: !info und .info hinzugefgt, !nextdj, .nextdj und nextdj hinzugefgt, .next und next hinzugefgt
#
# Version 0.3: Notices reduziert, Befehlschannel hinzugefgt
#
# Version 0.2: Welcome Message hinzugefgt
#
# Version 0.1: 1. Release fr #radio4life

set radio:version "0.8"
putlog "Radioscript ${radio:version} von Hangman5386 geladen."
